'GreyStroke - drawing using physics formulaes
'by Alain Brobecker (aka baah/Arm's Tech)
'2013jan28 - Blitzmax code
'2000feb13 - modified a bit so that it acts like GreyStroke
'1999jan17 - original version

Strict
'**** Modules needed for minimal executable
Framework BRL.GLMax2D
Import BRL.Basic

Const ScrW=1024
Const ScrH=600
Graphics ScrW,ScrH

Global mx#,my#,mb	'mouse position and buttons
Global ox#=0			'old solid's position
Global oy#=0
Global a#=0.75		'velocity absorption
Global b#=0.0625		'acceleration factor
Global x#=0
Global y#=0
Global vx#,vy#,ax#,ay#
Global NbPixels=0
Global Size#=8.0

'****
'**** Main loop
'****
While Not AppTerminate() And Not KeyHit(KEY_ESCAPE)
'	Cls
	mx#=MouseX()
	my#=MouseY()
	SetColor(0,0,0)
	DrawRect 0,ScrH-15,ScrW,15
	SetColor(255,0,0)
	DrawText "+ - C  ",0,ScrH-15
	SetColor(255,255,255)
	DrawText "     ls     "+String(Int(Size#)),0,ScrH-15
	
	mb=MouseDown(1)
	If mb Then
'		DrawRect 0,0,200,200
		ax#=(mx#-ox#)*b#  'here are the kinematics formulaes
		ay#=(my#-oy#)*b#
		vx#=vx#*a#+ax#
		vy#=vy#*a#+ay#
		x#=ox#+vx#
		y#=oy#+vy#
		SetColor(255,255,255)
		FatLine(ox#,oy#,Size#,x#,y#,Size#)
		NbPixels=NbPixels+1
		ox#=x#
		oy#=y#
	Else
'		DrawRect 0,0,100,100
'   SetScale 20,20
'   DrawText "  NO  ",0,0
		ox#=mx#          'actualise solid's position
		oy#=my#
		vx#=0
		vy#=0
		ax#=0
		ay#=0	
	EndIf
	
	If KeyDown(KEY_NUMADD) Size#=Size#+0.1
	If KeyDown(KEY_NUMSUBTRACT) Then
		Size#=Size#-0.1
		If Size#<1.0 Size#=1.0
	EndIf
	If KeyHit(KEY_C) Then
		Cls
		Flip
		Cls
		NbPixels=0
	EndIf
	Flip
Wend
FlushKeys
FlushMouse
End


'**** Draw a Fat Line
Function FatLine(x1#,y1#,r1#,x2#,y2#,r2#)
  Local dx#,dy#,dist#,nx#,ny#,x#[4],y#[4]
  DrawOval(x1#-r1#,y1#-r1#,2*r1#,2*r1#)
  DrawOval(x2#-r2#,y2#-r2#,2*r2#,2*r2#)
  dx#=x2#-x1#
  dy#=y2#-y1#
  dist#=dx#*dx#+dy#*dy#
  If dist#<>0 Then
    dist#=Sqr(dist#)
    nx#=dx#/dist#
    ny#=dy#/dist#
    x#[0]=x1#+ny#*r1#
    y#[0]=y1#-nx#*r1#
    x#[1]=x1#-ny#*r1#
    y#[1]=y1#+nx#*r1#
    x#[2]=x2#-ny#*r2#
    y#[2]=y2#+nx#*r2#
    x#[3]=x2#+ny#*r2#
    y#[3]=y2#-nx#*r2#
    Local FatLineTri1#[]=[x#[0],y#[0],x#[1],y#[1],x#[2],y#[2]]
	 DrawPoly FatLineTri1
    Local FatLineTri2#[]=[x#[0],y#[0],x#[3],y#[3],x#[2],y#[2]]
	 DrawPoly FatLineTri2
  EndIf
End Function
